/* Copyright (C) 2009 Sakse Dalum
 * 
 * This file is part of Poddie Server.
 * 
 * Poddie Server is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * Poddie Server is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * A copy of the GNU Affero General Public License can be found in the
 * file LICENSE. 
 */

/*
 *                         component.h  -  description
 *                         --------------------------------
 *   begin                : Tue Aug 16 2009
 *   copyright            : (C) 2009 by Sakse Dalum
 *   maintainer(s)        : Sakse "Don S" Dalum <don.s@yodanism.org>
 *   description          : Defines all components' functions, etc.
 *
 */

/// //////////////////////////////////////////////////////////////// ///
///                          PREPROCESSOR                            ///
/// //////////////////////////////////////////////////////////////// ///

#ifndef header_component
#define header_component

#if _MSC_VER > 1000
#pragma once
#endif

#include "../precomp.h"
#include "../world.h"
#include "player.h"
#include "missile.h"

/// //////////////////////////////////////////////////////////////// ///
///                    YET TO BE DEFINED CLASSES                     ///
/// //////////////////////////////////////////////////////////////// ///

class Player;

/// //////////////////////////////////////////////////////////////// ///
///                           DEFINITION                             ///
/// //////////////////////////////////////////////////////////////// ///

class Component {
public:
	// Constructor
	Component(int slot, std::string type, std::string part,
				std::string number, Player *owner, World *world);
	// Destructor
	~Component();
	
	// Object pointers
	Player *owner;
	World *world;
	
	// Component
	std::string type, part, number;
	
	// Slot
	int slot;
	
	// Activity
	bool active, increase, decrease;
	bool setPrevActivity;
	float activity, prevActivity;
	
	// Update
	float cooldown;
	void update();
};

#endif

