/* Copyright (C) 2009 Sakse Dalum
 * 
 * This file is part of Poddie Server.
 * 
 * Poddie Server is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * Poddie Server is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * A copy of the GNU Affero General Public License can be found in the
 * file LICENSE. 
 */

/*
 *                         gameobject.cpp  -  description
 *                         --------------------------------
 *   begin                : Tue Aug 13 2009
 *   copyright            : (C) 2009 by Sakse Dalum
 *   maintainer(s)        : Sakse "Don S" Dalum <don.s@yodanism.org>
 *   description          : Generic game object. Any variable or
 *                          function that belongs to all game objects, 
 *                          should be put in here.
 *
 */

#include "gameobject.h"

/***********************************************************************
*    *    *    *    *                              *    *    *    *    *
                            CON- & DESTRUCTORS
*    *    *    *    *                              *    *    *    *    *
***********************************************************************/

GameObject::GameObject(float x, float y, float angle, World *world) :
world(world), x(x), y(y), angle(angle) {
	hspeed = 0;
	vspeed = 0;
}

GameObject::GameObject() { }

GameObject::~GameObject() {
	
}

/***********************************************************************
*    *    *    *    *                              *    *    *    *    *
                                FUNCTIONS
*    *    *    *    *                              *    *    *    *    *
***********************************************************************/

////////////////////////////////////////////////////////////////////////
//                    MOVEMENT, POSITION & DIRECTION

void GameObject::set_position(float new_x, float new_y) { x = new_x; y = new_y; }

void GameObject::set_angle(float new_angle) { angle = new_angle; }
float GameObject::get_angle() { return angle; }

void GameObject::set_hspeed(float new_hspeed) { hspeed = new_hspeed; }
float GameObject::get_hspeed() { return hspeed; }

void GameObject::set_vspeed(float new_vspeed) { vspeed = new_vspeed; }
float GameObject::get_vspeed() { return vspeed; }

void GameObject::set_x(float new_x) { x = new_x; }
float GameObject::get_x() { return x; }

void GameObject::set_y(float new_y) { y = new_y; }
float GameObject::get_y() { return y; }
