/* Copyright (C) 2009 Sakse Dalum
 * 
 * This file is part of Poddie Server.
 * 
 * Poddie Server is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * Poddie Server is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * A copy of the GNU Affero General Public License can be found in the
 * file LICENSE. 
 */

/*
 *                         missile.h  -  description
 *                         --------------------------------
 *   begin                : Tue Aug 16 2009
 *   copyright            : (C) 2009 by Sakse Dalum
 *   maintainer(s)        : Sakse "Don S" Dalum <don.s@yodanism.org>
 *   description          : Any flying missile.
 *
 */

/// //////////////////////////////////////////////////////////////// ///
///                          PREPROCESSOR                            ///
/// //////////////////////////////////////////////////////////////// ///

#ifndef header_missile
#define header_missile

#if _MSC_VER > 1000
#pragma once
#endif

#include "../precomp.h"
#include "player.h"
#include "gameobject.h"
#include "../world.h"

/// //////////////////////////////////////////////////////////////// ///
///                    YET TO BE DEFINED CLASSES                     ///
/// //////////////////////////////////////////////////////////////// ///

class Player;

/// //////////////////////////////////////////////////////////////// ///
///                           DEFINITION                             ///
/// //////////////////////////////////////////////////////////////// ///

class Missile : public GameObject {
public:
	// Constructors
	Missile(float x, float y, float angle, float speed, Player *creator, World *world, string sprite);
	Missile();
	// Destructor
	~Missile();
	
	// Object pointers
	Player *creator;
	
	// Movement, position & direction
	float angle, radius;
	
	// Status
	bool alive;
	
	// Simple Physics
	void add_vector(float, float);
	
	// Collision
	bool collision_circle(float, float, float);
	
	// Sprite
	string sprite;
	
	// Update
	virtual void update();
	bool do_update;
};

#endif

